/*
 * This class has extensions for all the different types of cards.
 */
package saboteur;

/*
 * Authors: Dyon Veldhuis, Eric Jansen, Eveline Broers
 */

public class Card implements Cloneable{
    
    public Card() {
    }
    
    // Make it possible to clone cards
    public Object clone(){
        try{
            return super.clone();
        } catch (CloneNotSupportedException e){
            return null;
        }
    }  
}
