/*
 * This class defines the goal cards
 */

package saboteur;

/*
 * Authors: Dyon Veldhuis, Eric Jansen, Eveline Broers
 */

public class GoalCard extends PathCard{
    private boolean gold;
    
    // A goal card has open paths in every direction and it does or does not contain gold
    public GoalCard(boolean sides[], boolean opened[], boolean gold){
        super(sides, opened);
        this.gold = gold;        
    }
    
    // A player can look at a goal card and then knows whether there is gold on it or not
    public boolean getGold(){
        return gold;
    }
    
}
