/*
 * This class defines whether a player is a saboteur or a normal dwarf
 */
package saboteur;

/*
 * Authors: Dyon Veldhuis, Eric Jansen, Eveline Broers
 */

public class State {
    
    private boolean[] saboteurs;
    
    public State(boolean saboteurs[]){
        this.saboteurs = saboteurs;
    }
    
    public boolean getAgentRole(int agent){
        return saboteurs[agent];        
    }
    
    public int[] getSaboteurs(){
        int[] returnValue = new int[]{10,10};
        boolean second = false;
        for(int i = 0; i < 5; i++){
            if(saboteurs[i] && !second){
                returnValue[0] = i;
                second = true;
            } else if(saboteurs[i]){
                returnValue[1] = i;
            }
        }
        return returnValue;
    }
    
    public boolean haveSameRole(int agent1, int agent2){
        if(saboteurs[agent1] == saboteurs[agent2]){
            return true;
        }
        return false;
    }
}
