/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * Tutorial.java
 *
 * Created on Apr 3, 2012, 3:11:48 PM
 */
package saboteur;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashSet;
import java.util.Set;
import javax.swing.*;

/**
 *
 * @author s1692933
 */
public class Tutorial extends javax.swing.JFrame {
    
    int turn = 0;
    boolean next = true;
    boolean show = false;
    Label[][][] gridd=new Label[5][6*3][1*3]; //allocate the size of grid
    Label[] turnLabel = new Label[5];
    

    
    /** Creates new form Tutorial */
    public Tutorial() 
    {
        super();
        initComponents();
        turnLabel[0] = new Label("turn: player 1");
        turnLabel[1] = new Label("turn: player 2");
        turnLabel[2] = new Label("turn: player 3");
        turnLabel[3] = new Label("turn: player 4");
        turnLabel[4] = new Label("turn: player 5");
        for(int a = 0; a < 5; a++) {
            for(int z = 0; z < 6*3; z++) {
                for(int zz = 0; zz < 1*3; zz++) {
                    gridd[a][z][zz] = new Label(" "); //creates new label 
                }
            } 
        }
           
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);        
        setSize(1000,1000);
        setExtendedState(Frame.MAXIMIZED_BOTH);
        pack(); //sets appropriate size for frame
        setVisible(true); //makes frame visible     
    }
    
    public boolean getNext(){
        return next;
    }
        
    public void draw2(Card[][] board, int agent) {  
        int height = 6;
        int width = 1;           
        for(int x = 0; x<height; x++){
            for(int y = 0; y<width; y++){
                 if((board[x][y] instanceof BlockCard)) {
                    gridd[agent][x*3][y*3].setBackground(Color.red);
                    gridd[agent][x*3+1][y*3].setBackground(Color.red);
                    gridd[agent][x*3+2][y*3].setBackground(Color.red);
                    gridd[agent][x*3][y*3+1].setBackground(Color.red);   
                    gridd[agent][x*3+1][y*3+1].setBackground(Color.red);
                    gridd[agent][x*3+2][y*3+1].setBackground(Color.red);
                    gridd[agent][x*3][y*3+2].setBackground(Color.red);
                    gridd[agent][x*3+1][y*3+2].setBackground(Color.red);   
                    gridd[agent][x*3+2][y*3+2].setBackground(Color.red);
                } else if((board[x][y] instanceof DeblockCard)) {
                    gridd[agent][x*3][y*3].setBackground(Color.green);
                    gridd[agent][x*3+1][y*3].setBackground(Color.green);
                    gridd[agent][x*3+2][y*3].setBackground(Color.green);
                    gridd[agent][x*3][y*3+1].setBackground(Color.green);   
                    gridd[agent][x*3+1][y*3+1].setBackground(Color.green);
                    gridd[agent][x*3+2][y*3+1].setBackground(Color.green);
                    gridd[agent][x*3][y*3+2].setBackground(Color.green);
                    gridd[agent][x*3+1][y*3+2].setBackground(Color.green);   
                    gridd[agent][x*3+2][y*3+2].setBackground(Color.green);
               } else if((board[x][y] instanceof ViewCard)) {
                    gridd[agent][x*3][y*3].setBackground(Color.blue);
                    gridd[agent][x*3+1][y*3].setBackground(Color.blue);
                    gridd[agent][x*3+2][y*3].setBackground(Color.blue);
                    gridd[agent][x*3][y*3+1].setBackground(Color.blue);   
                    gridd[agent][x*3+1][y*3+1].setBackground(Color.black);
                    gridd[agent][x*3+2][y*3+1].setBackground(Color.blue);
                    gridd[agent][x*3][y*3+2].setBackground(Color.blue);
                    gridd[agent][x*3+1][y*3+2].setBackground(Color.blue);   
                    gridd[agent][x*3+2][y*3+2].setBackground(Color.blue);
               } else if((board[x][y] instanceof DemolishCard)) {
                    gridd[agent][x*3][y*3].setBackground(Color.yellow);
                    gridd[agent][x*3+1][y*3].setBackground(Color.yellow);
                    gridd[agent][x*3+2][y*3].setBackground(Color.yellow);
                    gridd[agent][x*3][y*3+1].setBackground(Color.yellow);   
                    gridd[agent][x*3+1][y*3+1].setBackground(Color.red);
                    gridd[agent][x*3+2][y*3+1].setBackground(Color.yellow);
                    gridd[agent][x*3][y*3+2].setBackground(Color.yellow);
                    gridd[agent][x*3+1][y*3+2].setBackground(Color.yellow);   
                    gridd[agent][x*3+2][y*3+2].setBackground(Color.yellow);
                } else {                                         
                    PathCard path = (PathCard)board[x][y];
                    boolean[] openings = path.getOpened(); 
                    boolean[] sides = path.getSides();
                    if(board[x][y] != null) {                       
                        if(openings[0] || openings[1] || openings[2] || openings[3]) {//if one opening is true
                            gridd[agent][x*3+1][y*3+1].setBackground(Color.white);//make mid tile white  
                        } else {
                            gridd[agent][x*3+1][y*3+1].setBackground(Color.black);//make mid tile black  
                        }
                        if(sides[0]) {//North
                            gridd[agent][x*3+1][y*3+2].setBackground(Color.white);  
                        } else {
                            gridd[agent][x*3+1][y*3+2].setBackground(Color.black);
                        }
                        if(sides[1]) {//East
                            gridd[agent][x*3][y*3+1].setBackground(Color.white);  
                        } else {
                            gridd[agent][x*3][y*3+1].setBackground(Color.black);
                        }
                        if(sides[2]) {//South
                            gridd[agent][x*3+1][y*3].setBackground(Color.white);  
                        } else {
                            gridd[agent][x*3+1][y*3].setBackground(Color.black); 
                        }
                        if(sides[3]) {//West
                            gridd[agent][x*3+2][y*3+1].setBackground(Color.white);  
                        } else {
                            gridd[agent][x*3+2][y*3+1].setBackground(Color.black);  
                        }
                        gridd[agent][x*3][y*3].setBackground(Color.black);//4 Corners
                        gridd[agent][x*3][y*3+2].setBackground(Color.black);
                        gridd[agent][x*3+2][y*3].setBackground(Color.black);
                        gridd[agent][x*3+2][y*3+2].setBackground(Color.black);                        
                    } else {                      
                        for(int z = 0; z < height*3; z++) {
                            for(int zz = 0; zz < width*3; zz++) {
                                switch(agent) {
                                    case 0: 
                                            jPanel1.setBackground(Color.white);
                                            break;
                                    case 1: 
                                            jPanel5.setBackground(Color.white);  
                                            break;
                                    case 2: 
                                            jPanel6.setBackground(Color.white);  
                                            break;
                                    case 3: 
                                            jPanel8.setBackground(Color.white);  
                                            break;
                                    case 4: 
                                            jPanel4.setBackground(Color.white);  
                                            break;                                        
                                }                                                                                 
                            }
                        } 
                    }
                }
            }
        }
       
        //for(int zz = 0; zz < width*3; zz++) {
        //    for(int z = 0; z < height*3; z++) { 
        //        gridd[agent][zz][z].setBackground(Color.white);
        //    }
       // }
        
        
        switch(agent) {
            case 0: jPanel7.removeAll();
                    jPanel7.add(turnLabel[0]); //adds button to grid
                    for(int zz = 0; zz < width*3; zz++) {
                        for(int z = 0; z < height*3; z++) {                   
                            jPanel1.add(gridd[agent][z][zz]); //adds button to grid 
                        }
                    }
                    break;
            case 1: jPanel7.removeAll();
                    jPanel7.add(turnLabel[1]); //adds button to grid
                    for(int zz = 0; zz < width*3; zz++) {
                        for(int z = 0; z < height*3; z++) { 
                            jPanel5.add(gridd[agent][z][zz]); //adds button to grid

                        }
                    }
                    break;
            case 2: jPanel7.removeAll();
                    jPanel7.add(turnLabel[2]); //adds button to grid
                    for(int zz = 0; zz < width*3; zz++) {
                        for(int z = 0; z < height*3; z++) { 
                            jPanel6.add(gridd[agent][z][zz]); //adds button to grid 
                        }
                    }
                    break;
            case 3: jPanel7.removeAll();
                    jPanel7.add(turnLabel[3]); //adds button to grid
                    for(int zz = 0; zz < width*3; zz++) {
                        for(int z = 0; z < height*3; z++) { 
                            jPanel8.add(gridd[agent][z][zz]); //adds button to grid 

                        }
                    }
                    break;
            case 4: jPanel7.removeAll();
                    jPanel7.add(turnLabel[4]); //adds button to grid
                    for(int zz = 0; zz < width*3; zz++) {
                        for(int z = 0; z < height*3; z++) { 
                            jPanel4.add(gridd[agent][z][zz]); //adds button to grid 

                        }
                    }
                    break;
        }    
      setVisible(true); //makes frame visible      
    }
    
    
    // <editor-fold>
    public void draw(PathCard[][] board) throws InterruptedException{
        jPanel2.removeAll();
        jPanel2.revalidate();
        jPanel2.repaint();
        //Thread.sleep(1000);
        Label[][] grid; //names the grid of buttons
        int height = 13;
        int width = 13;
        //Saboteur saboteur = new Saboteur();
        //board = saboteur.getBoard();
             
        grid=new Label[height*3][width*3]; //allocate the size of grid

        for(int z = 0; z < height*3; z++) {
            for(int zz = 0; zz < width*3; zz++) {
                grid[zz][z] = new Label(" "); //creates new label 
            }
        } 

        for(int x=0; x<height; x++){
            for(int y=0; y<width; y++){

                if(board[x][y] != null) {                       
                    boolean[] openings = board[x][y].getOpened(); 
                    boolean[] sides = board[x][y].getSides();

                    if(openings[0] || openings[1] || openings[2] || openings[3]) {//if one opening is true
                        grid[x*3+1][y*3+1].setBackground(Color.white);//make mid tile black  
                    } else {
                        grid[x*3+1][y*3+1].setBackground(Color.black);//make mid tile red  
                    }
                    if(sides[0]) {//North
                        grid[x*3+1][y*3+2].setBackground(Color.white);  
                    } else {
                        grid[x*3+1][y*3+2].setBackground(Color.black);
                    }
                    if(sides[1]) {//East
                        grid[x*3][y*3+1].setBackground(Color.white);  
                    } else {
                        grid[x*3][y*3+1].setBackground(Color.black);
                    }
                    if(sides[2]) {//South
                        grid[x*3+1][y*3].setBackground(Color.white);  
                    } else {
                        grid[x*3+1][y*3].setBackground(Color.black); 
                    }
                    if(sides[3]) {//West
                        grid[x*3+2][y*3+1].setBackground(Color.white);  
                    } else {
                        grid[x*3+2][y*3+1].setBackground(Color.black);  
                    }
                    grid[x*3][y*3].setBackground(Color.black);//4 Corners
                    grid[x*3][y*3+2].setBackground(Color.black);
                    grid[x*3+2][y*3].setBackground(Color.black);
                    grid[x*3+2][y*3+2].setBackground(Color.black);                        
                } else {
                    for(int z = 0; z < 13*3; z++) {
                        for(int zz = 0; zz < 13*3; zz++) {
                            jPanel2.setBackground(Color.white);
                        }
                    } 
                }
            }
        }
        for(int z = 0; z < 13*3; z++) {
            for(int zz = 0; zz < 13*3; zz++) {
                jPanel2.add(grid[zz][z]); //adds button to grid 
            }
        } 
        GoalCard card = (GoalCard)board[4][10];
        if(card.getGold()){
            grid[4*3+1][10*3+1].setBackground(Color.orange);                
        } else {
            grid[4*3+1][10*3+1].setBackground(Color.GRAY); 
        }
        card = (GoalCard)board[6][10];
        if(card.getGold()){
            grid[6*3+1][10*3+1].setBackground(Color.orange);                
        } else {
            grid[6*3+1][10*3+1].setBackground(Color.GRAY); 
        }
        card = (GoalCard)board[8][10];
        if(card.getGold()){
            grid[8*3+1][10*3+1].setBackground(Color.orange);                
        } else {
            grid[8*3+1][10*3+1].setBackground(Color.GRAY); 
        }
        grid[6*3+1][2*3+1].setBackground(Color.red);
        //return 0;
        
        
        setVisible(true); //makes frame visible 
    }
    // </editor-fold>
    
   
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel3 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setPreferredSize(new java.awt.Dimension(1400, 1600));
        java.awt.GridBagLayout layout = new java.awt.GridBagLayout();
        layout.columnWidths = new int[] {0, 5, 0, 5, 0, 5, 0};
        layout.rowHeights = new int[] {0, 5, 0, 5, 0, 5, 0, 5, 0};
        getContentPane().setLayout(layout);

        jPanel3.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel1.setMinimumSize(new java.awt.Dimension(240, 40));
        jPanel1.setPreferredSize(new java.awt.Dimension(240, 40));
        jPanel1.setLayout(new java.awt.GridLayout(3, 18, 1, 1));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        jPanel3.add(jPanel1, gridBagConstraints);

        jPanel5.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel5.setMinimumSize(new java.awt.Dimension(240, 40));
        jPanel5.setPreferredSize(new java.awt.Dimension(240, 40));
        jPanel5.setLayout(new java.awt.GridLayout(3, 18, 1, 1));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        jPanel3.add(jPanel5, gridBagConstraints);

        jPanel6.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel6.setMinimumSize(new java.awt.Dimension(240, 40));
        jPanel6.setPreferredSize(new java.awt.Dimension(240, 40));
        jPanel6.setLayout(new java.awt.GridLayout(3, 18, 1, 1));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        jPanel3.add(jPanel6, gridBagConstraints);

        jButton1.setText("Next");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1MouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel3.add(jButton1, gridBagConstraints);

        jButton2.setText("Show board");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton2MouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanel3.add(jButton2, gridBagConstraints);

        jPanel4.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel4.setMinimumSize(new java.awt.Dimension(240, 40));
        jPanel4.setPreferredSize(new java.awt.Dimension(240, 40));
        jPanel4.setLayout(new java.awt.GridLayout(3, 18, 1, 1));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        jPanel3.add(jPanel4, gridBagConstraints);

        jPanel8.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel8.setMinimumSize(new java.awt.Dimension(240, 40));
        jPanel8.setPreferredSize(new java.awt.Dimension(240, 40));
        jPanel8.setLayout(new java.awt.GridLayout(3, 18, 1, 1));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        jPanel3.add(jPanel8, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(jPanel3, gridBagConstraints);

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "E-Mail", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 12))); // NOI18N
        jPanel2.setMinimumSize(new java.awt.Dimension(800, 600));
        jPanel2.setPreferredSize(new java.awt.Dimension(1000, 800));
        jPanel2.setLayout(new java.awt.GridLayout(39, 39));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        getContentPane().add(jPanel2, gridBagConstraints);

        jPanel7.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel7.setPreferredSize(new java.awt.Dimension(200, 200));
        jPanel7.setLayout(new java.awt.GridLayout(5, 0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        getContentPane().add(jPanel7, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1MouseClicked
        next = true;
    }//GEN-LAST:event_jButton1MouseClicked

    private void jButton2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton2MouseClicked
        show = true;
    }//GEN-LAST:event_jButton2MouseClicked

    
    /**
     * @param args the command line arguments
     */
    /*public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new Tutorial().setVisible(true);
            }
        });
    }*/
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    // End of variables declaration//GEN-END:variables
}
