/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package saboteur;

import java.awt.*;
import java.awt.event.*;
import java.util.Arrays;
import javax.swing.*;

/**
 *
 * @author Administrator
 */
public class Display extends javax.swing.JFrame {
    JLabel[][] handCardLabelBoard = new JLabel[5][6];
    JLabel[][] labelBoard = new JLabel[13][13];
    JLabel[] playDiscardBoard = new JLabel[2];
    boolean next = false;
    boolean show = false;
    int agent = 10;
    int turn = 0;
    int round = 0;
    //All possible side configurations
    boolean fourConnections[] = new boolean[]{true, true, true, true};//URDL
    boolean threeConnectionsUp[] = new boolean[]{true, true, false, true};//URL
    boolean threeConnectionsLeft[] = new boolean[]{true, false, true, true};//UDL
    boolean twoConnectionsUpLeft[] = new boolean[]{true, false, false, true};//UL 
    boolean twoConnectionsUpRight[] = new boolean[]{true, true, false, false};//UR
    boolean twoConnectionsUpDown[] = new boolean[]{true, false, true, false};//UD
    boolean twoConnectionsLeftRight[] = new boolean[]{false, true, false, true};//RL
    boolean oneConnectionUp[] = new boolean[]{true, false, false, false};//U    
    boolean oneConnectionLeft[] = new boolean[]{false, false, false, true};//L
    
    boolean threeConnectionsDown[] = new boolean[]{false, true, true, true};//RDL
    boolean threeConnectionsRight[] = new boolean[]{true, true, true, false};//URD
    boolean twoConnectionsDownRight[] = new boolean[]{false, true, true, false};//RD 
    boolean twoConnectionsDownLeft[] = new boolean[]{false, false, true, true};//DL
    boolean oneConnectionDown[] = new boolean[]{false, false, true, false};//D   
    boolean oneConnectionRight[] = new boolean[]{false, true, false, false};//R
    
    Toolkit tk;
    Dimension dimension;
    int screenWidth;
    int screenHeight;
        
    public Display() {
        initComponents(); 
        initializeBoard();
        tk = Toolkit.getDefaultToolkit();
        dimension = tk.getScreenSize();
        screenWidth = dimension.width;
        screenHeight = dimension.height;


        Dimension windowSize = getSize();
        int windowWidth = windowSize.width;
        int windowHeight = windowSize.height;
        int X = (screenWidth - windowWidth)/2;
        int Y = (screenHeight - windowHeight)/2;
        setLocation(X, Y);
        
        this.setExtendedState(JFrame.MAXIMIZED_BOTH);            // Make sure layout is ok 
        setVisible(true); //makes frame visible 
                //setExtendedState(JFrame.MAXIMIZED_BOTH);
    }
    
    
    public void showGold(int j, int gold) {
        switch(j) {
            case 0: jLabel170.setText("gold" + ": " + gold);
                    break;
            case 1: jLabel173.setText("gold" + ": " + gold);
                    break;
            case 2: jLabel174.setText("gold" + ": " + gold);
                    break;
            case 3: jLabel175.setText("gold" + ": " + gold);
                    break;
            case 4: jLabel176.setText("gold" + ": " + gold);
                    break;                
        }
    }
    
    public void drawSaboteurs(boolean[] saboteurRole) {
        if(saboteurRole[0]) {
            jLabel178.setText("0: Saboteur");
        } else {
            jLabel178.setText("0: Agent");
        }
        if(saboteurRole[1]) {
            jLabel180.setText("1: Saboteur");
        } else {
            jLabel180.setText("1: Agent");
        }
        if(saboteurRole[2]) {
            jLabel182.setText("2: Saboteur");
        } else {
            jLabel182.setText("2: Agent");
        }
        if(saboteurRole[3]) {
            jLabel184.setText("3: Saboteur");
        } else {
            jLabel184.setText("3: Agent");
        }
        if(saboteurRole[4]) {
            jLabel186.setText("4: Saboteur");
        } else {
            jLabel186.setText("4: Agent");
        }
    }  
    
    public void setAgent(int ag) {
        this.agent = ag;
    }
    
    public void setLabel(int i) {
        switch(i) {
            case 0:   jLabel221.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/arrow.PNG"))); 
                      jLabel222.setIcon(null); 
                      jLabel223.setIcon(null); 
                      jLabel224.setIcon(null); 
                      jLabel225.setIcon(null); 
                      break;
            case 1:   jLabel222.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/arrow.PNG")));
                      jLabel221.setIcon(null); 
                      jLabel223.setIcon(null); 
                      jLabel224.setIcon(null); 
                      jLabel225.setIcon(null); 
                      break;
            case 2:   jLabel223.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/arrow.PNG")));
                      jLabel222.setIcon(null); 
                      jLabel221.setIcon(null); 
                      jLabel224.setIcon(null); 
                      jLabel225.setIcon(null); 
                      break;
            case 3:   jLabel224.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/arrow.PNG")));
                      jLabel222.setIcon(null); 
                      jLabel223.setIcon(null); 
                      jLabel221.setIcon(null); 
                      jLabel225.setIcon(null); 
                      break;
            case 4:   jLabel225.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/arrow.PNG")));
                      jLabel222.setIcon(null); 
                      jLabel223.setIcon(null); 
                      jLabel224.setIcon(null); 
                      jLabel221.setIcon(null); 
                      break;
        }
    }
    
    public void drawCard(Card card, JLabel label) {//draw right tile
        jButton1.setText("Next Turn (" + turn + ")");
        if(card instanceof ViewCard) {
            label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/view.PNG"))); 
        } 
        
        else if(card instanceof BlockCard) {
            label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/red.PNG"))); 
            switch(agent) {              
                case 0: label = jLabel179;
                        //System.out.println("case0");
                        break;
                case 1: label = jLabel181;
                        //System.out.println("case1");
                        break;
                case 2: label = jLabel183;
                        //System.out.println("case2");
                        break;
                case 3: label = jLabel185;
                        //System.out.println("case3");
                        break;
                case 4: label = jLabel187;
                        //System.out.println("case4");
                        break;
            }
            label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/red.PNG"))); 
        }  else if(card instanceof DeblockCard) {
            label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/green.PNG"))); 
            switch(agent) {
                case 0: label = jLabel179;
                        break;
                case 1: label = jLabel181;
                        break;
                case 2: label = jLabel183;
                        break;
                case 3: label = jLabel185;
                        break;
                case 4: label = jLabel187;
                        break;
            }
            label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/green.PNG")));
        }
        else if(card instanceof DemolishCard) {
            label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/demolish.PNG"))); 
        } else if(card instanceof GoalCard) {
                GoalCard goal = (GoalCard)card;
                if(goal.getGold()) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                } else {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                }
        } else if(card instanceof StartCard) {
            label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/start.PNG")));       
        } else if(card instanceof PathCard) {
            PathCard pathCard = (PathCard)card;
            boolean[] openings = pathCard.getOpened(); 
            boolean[] sides = pathCard.getSides();
            if(!(openings[0] || openings[1] || openings[2] || openings[3])) {//if one opening is true){System.out.println("ja"); //Dead end cards:
                if(Arrays.equals(sides,fourConnections)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/crossroadclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/crossroadclosed.PNG")));
                } 
                if(Arrays.equals(sides,threeConnectionsLeft)) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tleftclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tleftclosed.PNG")));
                }
                if(Arrays.equals(sides,threeConnectionsUp)) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tupclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tupclosed.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsUpLeft)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnleftupclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnleftupclosed.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsUpRight)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnuprightclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnuprightclosed.PNG")));
                }
                if(Arrays.equals(sides,oneConnectionLeft)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneleftclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneleftclosed.PNG")));
                }
                if(Arrays.equals(sides,oneConnectionUp)) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneupclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneupclosed.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsLeftRight)) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/straightleftrightclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneupclosed.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsUpDown)) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/straightupdownclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneupclosed.PNG")));
                }
                if(Arrays.equals(sides,threeConnectionsRight)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/trightclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/trightclosed.PNG")));
                }
                if(Arrays.equals(sides,threeConnectionsDown)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tdownclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tdownclosed.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsDownRight)) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnrightdownclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnrightdownclosed.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsDownLeft)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnleftdownclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnleftdownclosed.PNG")));
                }
                if(Arrays.equals(sides,oneConnectionRight)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/onerightclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/onerightclosed.PNG")));
                }
                if(Arrays.equals(sides,oneConnectionDown)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/onedownclosed.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/onedownclosed.PNG")));
                }     
            }

            else {//Open end Cards
                if(Arrays.equals(sides,fourConnections)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/crossroad.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/crossroad.PNG")));
                } 
                if(Arrays.equals(sides,threeConnectionsLeft)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tleft.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tleft.PNG")));
                }
                if(Arrays.equals(sides,threeConnectionsUp)) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tup.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tup.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsUpLeft)) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnleftup.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnleftup.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsUpRight )) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnupright.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnupright.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsLeftRight)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/straightleftright.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/straightleftright.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsUpDown)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/straightupdown.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/straightupdown.PNG")));
                }
                if(Arrays.equals(sides,oneConnectionLeft)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneleft.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneleft.PNG")));
                }
                if(Arrays.equals(sides,oneConnectionUp)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneup.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneup.PNG")));
                }
                if(Arrays.equals(sides,threeConnectionsRight)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tright.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tright.PNG")));
                }
                if(Arrays.equals(sides,threeConnectionsDown)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tdown.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tdown.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsDownRight)) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnrightdown.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnrightdown.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsDownLeft)) {
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnleftdown.PNG")));
                    //if(drawboard == false)
                    //jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnleftdown.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsLeftRight)) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/straightleftright.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneupclosed.PNG")));
                }
                if(Arrays.equals(sides,twoConnectionsUpDown)) { 
                    label.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/straightupdown.PNG")));
                    //if(drawboard == false)jLabel189.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/oneupclosed.PNG")));
                }
            }
        }

              //pack();
              agent = 10;
              setVisible(true); //makes frame visible  
    }

      

        
       
    
    public void draww(PathCard[][] board){//Get right label
        //jLabel189.setIcon(null);
        //jButton1.setText("Next Turn (" + turn + ")");
        jButton2.setText("Show Round " + (round+1));
        
        for(int x = 0; x < 13; x++) {
            for(int y = 0; y < 13; y++) {
                if(board[x][y] != null) {
                    drawCard(board[x][y], labelBoard[x][y]);    
                }
            }
        }
       
        setVisible(true); //makes frame visible      
    }
    
        
    public void initializeBoard(){
        handCardLabelBoard[0][0] = jLabel191;
        handCardLabelBoard[0][1] = jLabel192;
        handCardLabelBoard[0][2] = jLabel193;
        handCardLabelBoard[0][3] = jLabel194;
        handCardLabelBoard[0][4] = jLabel195;
        handCardLabelBoard[0][5] = jLabel196;
        
        handCardLabelBoard[1][0] = jLabel197;
        handCardLabelBoard[1][1] = jLabel198;
        handCardLabelBoard[1][2] = jLabel199;
        handCardLabelBoard[1][3] = jLabel200;
        handCardLabelBoard[1][4] = jLabel201;
        handCardLabelBoard[1][5] = jLabel202;
        
        handCardLabelBoard[2][0] = jLabel203;
        handCardLabelBoard[2][1] = jLabel204;
        handCardLabelBoard[2][2] = jLabel205;
        handCardLabelBoard[2][3] = jLabel206;
        handCardLabelBoard[2][4] = jLabel207;
        handCardLabelBoard[2][5] = jLabel208;
        
        handCardLabelBoard[3][0] = jLabel209;
        handCardLabelBoard[3][1] = jLabel210;
        handCardLabelBoard[3][2] = jLabel211;
        handCardLabelBoard[3][3] = jLabel212;
        handCardLabelBoard[3][4] = jLabel213;
        handCardLabelBoard[3][5] = jLabel214;
        
        handCardLabelBoard[4][0] = jLabel215;
        handCardLabelBoard[4][1] = jLabel216;
        handCardLabelBoard[4][2] = jLabel217;
        handCardLabelBoard[4][3] = jLabel218;
        handCardLabelBoard[4][4] = jLabel219;
        handCardLabelBoard[4][5] = jLabel220;
        
        playDiscardBoard[0] = jLabel189;
        playDiscardBoard[1] = jLabel171;        
        labelBoard[0][0] = jLabel1;
        labelBoard[0][1] = jLabel2;
        labelBoard[0][2] = jLabel3;
        labelBoard[0][3] = jLabel4;
        labelBoard[0][4] = jLabel5;
        labelBoard[0][5] = jLabel6;
        labelBoard[0][6] = jLabel7;
        labelBoard[0][7] = jLabel8;
        labelBoard[0][8] = jLabel9;
        labelBoard[0][9] = jLabel10;
        labelBoard[0][10] = jLabel11;
        labelBoard[0][11] = jLabel12;
        labelBoard[0][12] = jLabel13;

        labelBoard[1][0] = jLabel14;
        labelBoard[1][1] = jLabel15;
        labelBoard[1][2] = jLabel16;
        labelBoard[1][3] = jLabel17;
        labelBoard[1][4] = jLabel18;
        labelBoard[1][5] = jLabel19;
        labelBoard[1][6] = jLabel20;
        labelBoard[1][7] = jLabel21;
        labelBoard[1][8] = jLabel22;
        labelBoard[1][9] = jLabel23;
        labelBoard[1][10] = jLabel24;
        labelBoard[1][11] = jLabel25;
        labelBoard[1][12] = jLabel26;

        labelBoard[2][0] = jLabel27;
        labelBoard[2][1] = jLabel28;
        labelBoard[2][2] = jLabel29;
        labelBoard[2][3] = jLabel30;
        labelBoard[2][4] = jLabel31;
        labelBoard[2][5] = jLabel32;
        labelBoard[2][6] = jLabel33;
        labelBoard[2][7] = jLabel34;
        labelBoard[2][8] = jLabel35;
        labelBoard[2][9] = jLabel36;
        labelBoard[2][10] = jLabel37;
        labelBoard[2][11] = jLabel38;
        labelBoard[2][12] = jLabel39;

        labelBoard[3][0] = jLabel40;
        labelBoard[3][1] = jLabel41;
        labelBoard[3][2] = jLabel42;
        labelBoard[3][3] = jLabel43;
        labelBoard[3][4] = jLabel44;
        labelBoard[3][5] = jLabel45;
        labelBoard[3][6] = jLabel46;
        labelBoard[3][7] = jLabel47;
        labelBoard[3][8] = jLabel48;
        labelBoard[3][9] = jLabel49;
        labelBoard[3][10] = jLabel50;
        labelBoard[3][11] = jLabel51;
        labelBoard[3][12] = jLabel52;

        labelBoard[4][0] = jLabel53;
        labelBoard[4][1] = jLabel54;
        labelBoard[4][2] = jLabel55;
        labelBoard[4][3] = jLabel56;
        labelBoard[4][4] = jLabel57;
        labelBoard[4][5] = jLabel58;
        labelBoard[4][6] = jLabel59;
        labelBoard[4][7] = jLabel60;
        labelBoard[4][8] = jLabel61;
        labelBoard[4][9] = jLabel62;
        labelBoard[4][10] = jLabel63;
        labelBoard[4][11] = jLabel64;
        labelBoard[4][12] = jLabel65;

        labelBoard[5][0] = jLabel66;
        labelBoard[5][1] = jLabel67;
        labelBoard[5][2] = jLabel68;
        labelBoard[5][3] = jLabel69;
        labelBoard[5][4] = jLabel70;
        labelBoard[5][5] = jLabel71;
        labelBoard[5][6] = jLabel72;
        labelBoard[5][7] = jLabel73;
        labelBoard[5][8] = jLabel74;
        labelBoard[5][9] = jLabel75;
        labelBoard[5][10] = jLabel76;
        labelBoard[5][11] = jLabel77;
        labelBoard[5][12] = jLabel78;

        labelBoard[6][0] = jLabel79;
        labelBoard[6][1] = jLabel80;
        labelBoard[6][2] = jLabel81;
        labelBoard[6][3] = jLabel82;
        labelBoard[6][4] = jLabel83;
        labelBoard[6][5] = jLabel84;
        labelBoard[6][6] = jLabel85;
        labelBoard[6][7] = jLabel86;
        labelBoard[6][8] = jLabel87;
        labelBoard[6][9] = jLabel88;
        labelBoard[6][10] = jLabel89;
        labelBoard[6][11] = jLabel90;
        labelBoard[6][12] = jLabel91;

        labelBoard[7][0] = jLabel92;
        labelBoard[7][1] = jLabel93;
        labelBoard[7][2] = jLabel94;
        labelBoard[7][3] = jLabel95;
        labelBoard[7][4] = jLabel96;
        labelBoard[7][5] = jLabel97;
        labelBoard[7][6] = jLabel98;
        labelBoard[7][7] = jLabel99;
        labelBoard[7][8] = jLabel100;
        labelBoard[7][9] = jLabel101;
        labelBoard[7][10] = jLabel102;
        labelBoard[7][11] = jLabel103;
        labelBoard[7][12] = jLabel104;

        labelBoard[8][0] = jLabel105;
        labelBoard[8][1] = jLabel106;
        labelBoard[8][2] = jLabel107;
        labelBoard[8][3] = jLabel108;
        labelBoard[8][4] = jLabel109;
        labelBoard[8][5] = jLabel110;
        labelBoard[8][6] = jLabel111;
        labelBoard[8][7] = jLabel112;
        labelBoard[8][8] = jLabel113;
        labelBoard[8][9] = jLabel114;
        labelBoard[8][10] = jLabel115;
        labelBoard[8][11] = jLabel116;
        labelBoard[8][12] = jLabel117;

        labelBoard[9][0] = jLabel118;
        labelBoard[9][1] = jLabel119;
        labelBoard[9][2] = jLabel120;
        labelBoard[9][3] = jLabel121;
        labelBoard[9][4] = jLabel122;
        labelBoard[9][5] = jLabel123;
        labelBoard[9][6] = jLabel124;
        labelBoard[9][7] = jLabel125;
        labelBoard[9][8] = jLabel126;
        labelBoard[9][9] = jLabel127;
        labelBoard[9][10] = jLabel128;
        labelBoard[9][11] = jLabel129;
        labelBoard[9][12] = jLabel130;

        labelBoard[10][0] = jLabel131;
        labelBoard[10][1] = jLabel132;
        labelBoard[10][2] = jLabel133;
        labelBoard[10][3] = jLabel134;
        labelBoard[10][4] = jLabel135;
        labelBoard[10][5] = jLabel136;
        labelBoard[10][6] = jLabel137;
        labelBoard[10][7] = jLabel138;
        labelBoard[10][8] = jLabel139;
        labelBoard[10][9] = jLabel140;
        labelBoard[10][10] = jLabel141;
        labelBoard[10][11] = jLabel142;
        labelBoard[10][12] = jLabel143;

        labelBoard[11][0] = jLabel144;
        labelBoard[11][1] = jLabel145;
        labelBoard[11][2] = jLabel146;
        labelBoard[11][3] = jLabel147;
        labelBoard[11][4] = jLabel148;
        labelBoard[11][5] = jLabel149;
        labelBoard[11][6] = jLabel150;
        labelBoard[11][7] = jLabel151;
        labelBoard[11][8] = jLabel152;
        labelBoard[11][9] = jLabel153;
        labelBoard[11][10] = jLabel154;
        labelBoard[11][11] = jLabel155;
        labelBoard[11][12] = jLabel156;

        labelBoard[12][0] = jLabel157;
        labelBoard[12][1] = jLabel158;
        labelBoard[12][2] = jLabel159;
        labelBoard[12][3] = jLabel160;
        labelBoard[12][4] = jLabel161;
        labelBoard[12][5] = jLabel162;
        labelBoard[12][6] = jLabel163;
        labelBoard[12][7] = jLabel164;
        labelBoard[12][8] = jLabel165;
        labelBoard[12][9] = jLabel166;
        labelBoard[12][10] = jLabel167;
        labelBoard[12][11] = jLabel168;
        labelBoard[12][12] = jLabel169;
        
        for(int x = 0; x < 13; x++){
            for(int y = 0; y < 13; y++){
                labelBoard[x][y].setIcon(null);
            }    
        }
    }
        
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel3 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();
        jLabel24 = new javax.swing.JLabel();
        jLabel25 = new javax.swing.JLabel();
        jLabel26 = new javax.swing.JLabel();
        jLabel27 = new javax.swing.JLabel();
        jLabel28 = new javax.swing.JLabel();
        jLabel29 = new javax.swing.JLabel();
        jLabel30 = new javax.swing.JLabel();
        jLabel31 = new javax.swing.JLabel();
        jLabel32 = new javax.swing.JLabel();
        jLabel33 = new javax.swing.JLabel();
        jLabel34 = new javax.swing.JLabel();
        jLabel35 = new javax.swing.JLabel();
        jLabel36 = new javax.swing.JLabel();
        jLabel37 = new javax.swing.JLabel();
        jLabel38 = new javax.swing.JLabel();
        jLabel39 = new javax.swing.JLabel();
        jLabel40 = new javax.swing.JLabel();
        jLabel41 = new javax.swing.JLabel();
        jLabel42 = new javax.swing.JLabel();
        jLabel43 = new javax.swing.JLabel();
        jLabel44 = new javax.swing.JLabel();
        jLabel45 = new javax.swing.JLabel();
        jLabel46 = new javax.swing.JLabel();
        jLabel47 = new javax.swing.JLabel();
        jLabel48 = new javax.swing.JLabel();
        jLabel49 = new javax.swing.JLabel();
        jLabel50 = new javax.swing.JLabel();
        jLabel51 = new javax.swing.JLabel();
        jLabel52 = new javax.swing.JLabel();
        jLabel53 = new javax.swing.JLabel();
        jLabel54 = new javax.swing.JLabel();
        jLabel55 = new javax.swing.JLabel();
        jLabel56 = new javax.swing.JLabel();
        jLabel57 = new javax.swing.JLabel();
        jLabel58 = new javax.swing.JLabel();
        jLabel59 = new javax.swing.JLabel();
        jLabel60 = new javax.swing.JLabel();
        jLabel61 = new javax.swing.JLabel();
        jLabel62 = new javax.swing.JLabel();
        jLabel63 = new javax.swing.JLabel();
        jLabel64 = new javax.swing.JLabel();
        jLabel65 = new javax.swing.JLabel();
        jLabel66 = new javax.swing.JLabel();
        jLabel67 = new javax.swing.JLabel();
        jLabel68 = new javax.swing.JLabel();
        jLabel69 = new javax.swing.JLabel();
        jLabel70 = new javax.swing.JLabel();
        jLabel71 = new javax.swing.JLabel();
        jLabel72 = new javax.swing.JLabel();
        jLabel73 = new javax.swing.JLabel();
        jLabel74 = new javax.swing.JLabel();
        jLabel75 = new javax.swing.JLabel();
        jLabel76 = new javax.swing.JLabel();
        jLabel77 = new javax.swing.JLabel();
        jLabel78 = new javax.swing.JLabel();
        jLabel79 = new javax.swing.JLabel();
        jLabel80 = new javax.swing.JLabel();
        jLabel81 = new javax.swing.JLabel();
        jLabel82 = new javax.swing.JLabel();
        jLabel83 = new javax.swing.JLabel();
        jLabel84 = new javax.swing.JLabel();
        jLabel85 = new javax.swing.JLabel();
        jLabel86 = new javax.swing.JLabel();
        jLabel87 = new javax.swing.JLabel();
        jLabel88 = new javax.swing.JLabel();
        jLabel89 = new javax.swing.JLabel();
        jLabel90 = new javax.swing.JLabel();
        jLabel91 = new javax.swing.JLabel();
        jLabel92 = new javax.swing.JLabel();
        jLabel93 = new javax.swing.JLabel();
        jLabel94 = new javax.swing.JLabel();
        jLabel95 = new javax.swing.JLabel();
        jLabel96 = new javax.swing.JLabel();
        jLabel97 = new javax.swing.JLabel();
        jLabel98 = new javax.swing.JLabel();
        jLabel99 = new javax.swing.JLabel();
        jLabel100 = new javax.swing.JLabel();
        jLabel101 = new javax.swing.JLabel();
        jLabel102 = new javax.swing.JLabel();
        jLabel103 = new javax.swing.JLabel();
        jLabel104 = new javax.swing.JLabel();
        jLabel105 = new javax.swing.JLabel();
        jLabel106 = new javax.swing.JLabel();
        jLabel107 = new javax.swing.JLabel();
        jLabel108 = new javax.swing.JLabel();
        jLabel109 = new javax.swing.JLabel();
        jLabel110 = new javax.swing.JLabel();
        jLabel111 = new javax.swing.JLabel();
        jLabel112 = new javax.swing.JLabel();
        jLabel113 = new javax.swing.JLabel();
        jLabel114 = new javax.swing.JLabel();
        jLabel115 = new javax.swing.JLabel();
        jLabel116 = new javax.swing.JLabel();
        jLabel117 = new javax.swing.JLabel();
        jLabel118 = new javax.swing.JLabel();
        jLabel119 = new javax.swing.JLabel();
        jLabel120 = new javax.swing.JLabel();
        jLabel121 = new javax.swing.JLabel();
        jLabel122 = new javax.swing.JLabel();
        jLabel123 = new javax.swing.JLabel();
        jLabel124 = new javax.swing.JLabel();
        jLabel125 = new javax.swing.JLabel();
        jLabel126 = new javax.swing.JLabel();
        jLabel127 = new javax.swing.JLabel();
        jLabel128 = new javax.swing.JLabel();
        jLabel129 = new javax.swing.JLabel();
        jLabel130 = new javax.swing.JLabel();
        jLabel131 = new javax.swing.JLabel();
        jLabel132 = new javax.swing.JLabel();
        jLabel133 = new javax.swing.JLabel();
        jLabel134 = new javax.swing.JLabel();
        jLabel135 = new javax.swing.JLabel();
        jLabel136 = new javax.swing.JLabel();
        jLabel137 = new javax.swing.JLabel();
        jLabel138 = new javax.swing.JLabel();
        jLabel139 = new javax.swing.JLabel();
        jLabel140 = new javax.swing.JLabel();
        jLabel141 = new javax.swing.JLabel();
        jLabel142 = new javax.swing.JLabel();
        jLabel143 = new javax.swing.JLabel();
        jLabel144 = new javax.swing.JLabel();
        jLabel145 = new javax.swing.JLabel();
        jLabel146 = new javax.swing.JLabel();
        jLabel147 = new javax.swing.JLabel();
        jLabel148 = new javax.swing.JLabel();
        jLabel149 = new javax.swing.JLabel();
        jLabel150 = new javax.swing.JLabel();
        jLabel151 = new javax.swing.JLabel();
        jLabel152 = new javax.swing.JLabel();
        jLabel153 = new javax.swing.JLabel();
        jLabel154 = new javax.swing.JLabel();
        jLabel155 = new javax.swing.JLabel();
        jLabel156 = new javax.swing.JLabel();
        jLabel157 = new javax.swing.JLabel();
        jLabel158 = new javax.swing.JLabel();
        jLabel159 = new javax.swing.JLabel();
        jLabel160 = new javax.swing.JLabel();
        jLabel161 = new javax.swing.JLabel();
        jLabel162 = new javax.swing.JLabel();
        jLabel163 = new javax.swing.JLabel();
        jLabel164 = new javax.swing.JLabel();
        jLabel165 = new javax.swing.JLabel();
        jLabel166 = new javax.swing.JLabel();
        jLabel167 = new javax.swing.JLabel();
        jLabel168 = new javax.swing.JLabel();
        jLabel169 = new javax.swing.JLabel();
        jPanel26 = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        jLabel188 = new javax.swing.JLabel();
        jLabel189 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel172 = new javax.swing.JLabel();
        jLabel171 = new javax.swing.JLabel();
        jPanel27 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel17 = new javax.swing.JPanel();
        jLabel190 = new javax.swing.JLabel();
        jLabel229 = new javax.swing.JLabel();
        jPanel18 = new javax.swing.JPanel();
        jLabel230 = new javax.swing.JLabel();
        jLabel231 = new javax.swing.JLabel();
        jPanel19 = new javax.swing.JPanel();
        jLabel232 = new javax.swing.JLabel();
        jLabel233 = new javax.swing.JLabel();
        jPanel20 = new javax.swing.JPanel();
        jLabel234 = new javax.swing.JLabel();
        jLabel235 = new javax.swing.JLabel();
        jPanel21 = new javax.swing.JPanel();
        jLabel236 = new javax.swing.JLabel();
        jLabel237 = new javax.swing.JLabel();
        jPanel22 = new javax.swing.JPanel();
        jLabel238 = new javax.swing.JLabel();
        jLabel239 = new javax.swing.JLabel();
        jPanel23 = new javax.swing.JPanel();
        jLabel240 = new javax.swing.JLabel();
        jLabel241 = new javax.swing.JLabel();
        jPanel24 = new javax.swing.JPanel();
        jLabel242 = new javax.swing.JLabel();
        jLabel243 = new javax.swing.JLabel();
        jPanel25 = new javax.swing.JPanel();
        jLabel244 = new javax.swing.JLabel();
        jLabel245 = new javax.swing.JLabel();
        jPanel16 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jLabel221 = new javax.swing.JLabel();
        jLabel178 = new javax.swing.JLabel();
        jLabel179 = new javax.swing.JLabel();
        jLabel170 = new javax.swing.JLabel();
        jPanel11 = new javax.swing.JPanel();
        jLabel191 = new javax.swing.JLabel();
        jLabel192 = new javax.swing.JLabel();
        jLabel193 = new javax.swing.JLabel();
        jLabel194 = new javax.swing.JLabel();
        jLabel195 = new javax.swing.JLabel();
        jLabel196 = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jLabel222 = new javax.swing.JLabel();
        jLabel180 = new javax.swing.JLabel();
        jLabel181 = new javax.swing.JLabel();
        jLabel173 = new javax.swing.JLabel();
        jPanel12 = new javax.swing.JPanel();
        jLabel197 = new javax.swing.JLabel();
        jLabel198 = new javax.swing.JLabel();
        jLabel199 = new javax.swing.JLabel();
        jLabel200 = new javax.swing.JLabel();
        jLabel201 = new javax.swing.JLabel();
        jLabel202 = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        jLabel223 = new javax.swing.JLabel();
        jLabel182 = new javax.swing.JLabel();
        jLabel183 = new javax.swing.JLabel();
        jLabel174 = new javax.swing.JLabel();
        jPanel13 = new javax.swing.JPanel();
        jLabel203 = new javax.swing.JLabel();
        jLabel204 = new javax.swing.JLabel();
        jLabel205 = new javax.swing.JLabel();
        jLabel206 = new javax.swing.JLabel();
        jLabel207 = new javax.swing.JLabel();
        jLabel208 = new javax.swing.JLabel();
        jPanel8 = new javax.swing.JPanel();
        jLabel224 = new javax.swing.JLabel();
        jLabel184 = new javax.swing.JLabel();
        jLabel185 = new javax.swing.JLabel();
        jLabel175 = new javax.swing.JLabel();
        jPanel14 = new javax.swing.JPanel();
        jLabel209 = new javax.swing.JLabel();
        jLabel210 = new javax.swing.JLabel();
        jLabel211 = new javax.swing.JLabel();
        jLabel212 = new javax.swing.JLabel();
        jLabel213 = new javax.swing.JLabel();
        jLabel214 = new javax.swing.JLabel();
        jPanel9 = new javax.swing.JPanel();
        jLabel225 = new javax.swing.JLabel();
        jLabel186 = new javax.swing.JLabel();
        jLabel187 = new javax.swing.JLabel();
        jLabel176 = new javax.swing.JLabel();
        jPanel15 = new javax.swing.JPanel();
        jLabel215 = new javax.swing.JLabel();
        jLabel216 = new javax.swing.JLabel();
        jLabel217 = new javax.swing.JLabel();
        jLabel218 = new javax.swing.JLabel();
        jLabel219 = new javax.swing.JLabel();
        jLabel220 = new javax.swing.JLabel();
        jPanel28 = new javax.swing.JPanel();
        jLabel226 = new javax.swing.JLabel();
        jLabel227 = new javax.swing.JLabel();
        jLabel228 = new javax.swing.JLabel();
        jPanel29 = new javax.swing.JPanel();
        jLabel246 = new javax.swing.JLabel();
        jLabel247 = new javax.swing.JLabel();
        jLabel248 = new javax.swing.JLabel();
        jPanel30 = new javax.swing.JPanel();
        jLabel249 = new javax.swing.JLabel();
        jLabel250 = new javax.swing.JLabel();
        jLabel251 = new javax.swing.JLabel();
        jPanel31 = new javax.swing.JPanel();
        jLabel252 = new javax.swing.JLabel();
        jLabel253 = new javax.swing.JLabel();
        jLabel254 = new javax.swing.JLabel();
        jPanel32 = new javax.swing.JPanel();
        jLabel255 = new javax.swing.JLabel();
        jLabel256 = new javax.swing.JLabel();
        jLabel257 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setBackground(new java.awt.Color(0, 0, 0));
        getContentPane().setLayout(new java.awt.GridBagLayout());

        jPanel3.setBackground(new java.awt.Color(245, 245, 245));
        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Board", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Aharoni", 1, 14))); // NOI18N
        jPanel3.setMaximumSize(null);
        jPanel3.setMinimumSize(null);
        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel1.setBackground(new java.awt.Color(245, 245, 245));
        jPanel1.setAlignmentX(0.0F);
        jPanel1.setAlignmentY(0.0F);
        jPanel1.setMinimumSize(null);
        jPanel1.setPreferredSize(new java.awt.Dimension(300, 400));
        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel1.setBackground(new java.awt.Color(255, 255, 255));
        jLabel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel1.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel1.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel1.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        jPanel1.add(jLabel1, gridBagConstraints);

        jLabel2.setBackground(new java.awt.Color(255, 255, 255));
        jLabel2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel2.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel2.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel2.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel2, gridBagConstraints);

        jLabel3.setBackground(new java.awt.Color(255, 255, 255));
        jLabel3.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel3.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel3.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel3.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel3, gridBagConstraints);

        jLabel4.setBackground(new java.awt.Color(255, 255, 255));
        jLabel4.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel4.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel4.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel4.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel4, gridBagConstraints);

        jLabel5.setBackground(new java.awt.Color(255, 255, 255));
        jLabel5.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel5.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel5.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel5.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel5, gridBagConstraints);

        jLabel6.setBackground(new java.awt.Color(255, 255, 255));
        jLabel6.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel6.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel6.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel6.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel6, gridBagConstraints);

        jLabel7.setBackground(new java.awt.Color(255, 255, 255));
        jLabel7.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel7.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel7.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel7.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel7, gridBagConstraints);

        jLabel8.setBackground(new java.awt.Color(255, 255, 255));
        jLabel8.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel8.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel8.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel8.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel8, gridBagConstraints);

        jLabel9.setBackground(new java.awt.Color(255, 255, 255));
        jLabel9.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel9.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel9.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel9.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel9, gridBagConstraints);

        jLabel10.setBackground(new java.awt.Color(255, 255, 255));
        jLabel10.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel10.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel10.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel10.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel10, gridBagConstraints);

        jLabel11.setBackground(new java.awt.Color(255, 255, 255));
        jLabel11.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel11.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel11.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel11.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel11, gridBagConstraints);

        jLabel12.setBackground(new java.awt.Color(255, 255, 255));
        jLabel12.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel12.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel12.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel12.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel12, gridBagConstraints);

        jLabel13.setBackground(new java.awt.Color(255, 255, 255));
        jLabel13.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel13.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel13.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel13.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel13, gridBagConstraints);

        jLabel14.setBackground(new java.awt.Color(255, 255, 255));
        jLabel14.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel14.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel14.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel14.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel14, new java.awt.GridBagConstraints());

        jLabel15.setBackground(new java.awt.Color(255, 255, 255));
        jLabel15.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel15.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel15.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel15.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel15, gridBagConstraints);

        jLabel16.setBackground(new java.awt.Color(255, 255, 255));
        jLabel16.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel16.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel16.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel16.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel16, gridBagConstraints);

        jLabel17.setBackground(new java.awt.Color(255, 255, 255));
        jLabel17.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel17.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel17.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel17.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel17, gridBagConstraints);

        jLabel18.setBackground(new java.awt.Color(255, 255, 255));
        jLabel18.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel18.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel18.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel18.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel18, gridBagConstraints);

        jLabel19.setBackground(new java.awt.Color(255, 255, 255));
        jLabel19.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel19.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel19.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel19.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel19, gridBagConstraints);

        jLabel20.setBackground(new java.awt.Color(255, 255, 255));
        jLabel20.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel20.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel20.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel20.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel20, gridBagConstraints);

        jLabel21.setBackground(new java.awt.Color(255, 255, 255));
        jLabel21.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel21.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel21.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel21.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel21, gridBagConstraints);

        jLabel22.setBackground(new java.awt.Color(255, 255, 255));
        jLabel22.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel22.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel22.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel22.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel22, gridBagConstraints);

        jLabel23.setBackground(new java.awt.Color(255, 255, 255));
        jLabel23.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel23.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel23.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel23.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel23, gridBagConstraints);

        jLabel24.setBackground(new java.awt.Color(255, 255, 255));
        jLabel24.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel24.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel24.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel24.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel24, gridBagConstraints);

        jLabel25.setBackground(new java.awt.Color(255, 255, 255));
        jLabel25.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel25.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel25.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel25.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel25, gridBagConstraints);

        jLabel26.setBackground(new java.awt.Color(255, 255, 255));
        jLabel26.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel26.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel26.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel26.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel26, gridBagConstraints);

        jLabel27.setBackground(new java.awt.Color(255, 255, 255));
        jLabel27.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel27.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel27.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel27.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel27, new java.awt.GridBagConstraints());

        jLabel28.setBackground(new java.awt.Color(255, 255, 255));
        jLabel28.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel28.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel28.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel28.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel28, gridBagConstraints);

        jLabel29.setBackground(new java.awt.Color(255, 255, 255));
        jLabel29.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel29.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel29.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel29.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel29, gridBagConstraints);

        jLabel30.setBackground(new java.awt.Color(255, 255, 255));
        jLabel30.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel30.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel30.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel30.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel30, gridBagConstraints);

        jLabel31.setBackground(new java.awt.Color(255, 255, 255));
        jLabel31.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel31.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel31.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel31.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel31, gridBagConstraints);

        jLabel32.setBackground(new java.awt.Color(255, 255, 255));
        jLabel32.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel32.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel32.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel32.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel32, gridBagConstraints);

        jLabel33.setBackground(new java.awt.Color(255, 255, 255));
        jLabel33.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel33.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel33.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel33.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel33, gridBagConstraints);

        jLabel34.setBackground(new java.awt.Color(255, 255, 255));
        jLabel34.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel34.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel34.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel34.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel34, gridBagConstraints);

        jLabel35.setBackground(new java.awt.Color(255, 255, 255));
        jLabel35.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel35.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel35.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel35.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel35, gridBagConstraints);

        jLabel36.setBackground(new java.awt.Color(255, 255, 255));
        jLabel36.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel36.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel36.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel36.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel36, gridBagConstraints);

        jLabel37.setBackground(new java.awt.Color(255, 255, 255));
        jLabel37.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel37.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel37.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel37.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel37, gridBagConstraints);

        jLabel38.setBackground(new java.awt.Color(255, 255, 255));
        jLabel38.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel38.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel38.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel38.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel38, gridBagConstraints);

        jLabel39.setBackground(new java.awt.Color(255, 255, 255));
        jLabel39.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel39.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel39.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel39.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel39, gridBagConstraints);

        jLabel40.setBackground(new java.awt.Color(255, 255, 255));
        jLabel40.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel40.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel40.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel40.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel40, new java.awt.GridBagConstraints());

        jLabel41.setBackground(new java.awt.Color(255, 255, 255));
        jLabel41.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel41.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel41.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel41.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel41, gridBagConstraints);

        jLabel42.setBackground(new java.awt.Color(255, 255, 255));
        jLabel42.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel42.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel42.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel42.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel42, gridBagConstraints);

        jLabel43.setBackground(new java.awt.Color(255, 255, 255));
        jLabel43.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel43.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel43.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel43.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel43, gridBagConstraints);

        jLabel44.setBackground(new java.awt.Color(255, 255, 255));
        jLabel44.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel44.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel44.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel44.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel44, gridBagConstraints);

        jLabel45.setBackground(new java.awt.Color(255, 255, 255));
        jLabel45.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel45.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel45.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel45.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel45, gridBagConstraints);

        jLabel46.setBackground(new java.awt.Color(255, 255, 255));
        jLabel46.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel46.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel46.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel46.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel46, gridBagConstraints);

        jLabel47.setBackground(new java.awt.Color(255, 255, 255));
        jLabel47.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel47.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel47.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel47.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel47, gridBagConstraints);

        jLabel48.setBackground(new java.awt.Color(255, 255, 255));
        jLabel48.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel48.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel48.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel48.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel48, gridBagConstraints);

        jLabel49.setBackground(new java.awt.Color(255, 255, 255));
        jLabel49.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel49.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel49.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel49.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel49, gridBagConstraints);

        jLabel50.setBackground(new java.awt.Color(255, 255, 255));
        jLabel50.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel50.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel50.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel50.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel50, gridBagConstraints);

        jLabel51.setBackground(new java.awt.Color(255, 255, 255));
        jLabel51.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel51.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel51.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel51.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel51, gridBagConstraints);

        jLabel52.setBackground(new java.awt.Color(255, 255, 255));
        jLabel52.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel52.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel52.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel52.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel52, gridBagConstraints);

        jLabel53.setBackground(new java.awt.Color(255, 255, 255));
        jLabel53.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel53.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel53.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel53.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel53, new java.awt.GridBagConstraints());

        jLabel54.setBackground(new java.awt.Color(255, 255, 255));
        jLabel54.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel54.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel54.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel54.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel54, gridBagConstraints);

        jLabel55.setBackground(new java.awt.Color(255, 255, 255));
        jLabel55.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel55.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel55.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel55.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel55, gridBagConstraints);

        jLabel56.setBackground(new java.awt.Color(255, 255, 255));
        jLabel56.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel56.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel56.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel56.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel56, gridBagConstraints);

        jLabel57.setBackground(new java.awt.Color(255, 255, 255));
        jLabel57.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel57.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel57.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel57.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel57, gridBagConstraints);

        jLabel58.setBackground(new java.awt.Color(255, 255, 255));
        jLabel58.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel58.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel58.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel58.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel58, gridBagConstraints);

        jLabel59.setBackground(new java.awt.Color(255, 255, 255));
        jLabel59.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel59.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel59.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel59.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel59, gridBagConstraints);

        jLabel60.setBackground(new java.awt.Color(255, 255, 255));
        jLabel60.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel60.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel60.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel60.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel60, gridBagConstraints);

        jLabel61.setBackground(new java.awt.Color(255, 255, 255));
        jLabel61.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel61.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel61.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel61.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel61, gridBagConstraints);

        jLabel62.setBackground(new java.awt.Color(255, 255, 255));
        jLabel62.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel62.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel62.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel62.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel62, gridBagConstraints);

        jLabel63.setBackground(new java.awt.Color(255, 255, 255));
        jLabel63.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel63.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel63.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel63.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel63, gridBagConstraints);

        jLabel64.setBackground(new java.awt.Color(255, 255, 255));
        jLabel64.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel64.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel64.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel64.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel64, gridBagConstraints);

        jLabel65.setBackground(new java.awt.Color(255, 255, 255));
        jLabel65.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel65.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel65.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel65.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel65, gridBagConstraints);

        jLabel66.setBackground(new java.awt.Color(255, 255, 255));
        jLabel66.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel66.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel66.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel66.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel66, new java.awt.GridBagConstraints());

        jLabel67.setBackground(new java.awt.Color(255, 255, 255));
        jLabel67.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel67.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel67.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel67.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel67, gridBagConstraints);

        jLabel68.setBackground(new java.awt.Color(255, 255, 255));
        jLabel68.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel68.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel68.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel68.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel68, gridBagConstraints);

        jLabel69.setBackground(new java.awt.Color(255, 255, 255));
        jLabel69.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel69.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel69.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel69.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel69, gridBagConstraints);

        jLabel70.setBackground(new java.awt.Color(255, 255, 255));
        jLabel70.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel70.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel70.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel70.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel70, gridBagConstraints);

        jLabel71.setBackground(new java.awt.Color(255, 255, 255));
        jLabel71.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel71.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel71.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel71.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel71, gridBagConstraints);

        jLabel72.setBackground(new java.awt.Color(255, 255, 255));
        jLabel72.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel72.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel72.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel72.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel72, gridBagConstraints);

        jLabel73.setBackground(new java.awt.Color(255, 255, 255));
        jLabel73.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel73.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel73.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel73.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel73, gridBagConstraints);

        jLabel74.setBackground(new java.awt.Color(255, 255, 255));
        jLabel74.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel74.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel74.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel74.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel74, gridBagConstraints);

        jLabel75.setBackground(new java.awt.Color(255, 255, 255));
        jLabel75.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel75.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel75.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel75.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel75, gridBagConstraints);

        jLabel76.setBackground(new java.awt.Color(255, 255, 255));
        jLabel76.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel76.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel76.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel76.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel76, gridBagConstraints);

        jLabel77.setBackground(new java.awt.Color(255, 255, 255));
        jLabel77.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel77.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel77.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel77.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel77, gridBagConstraints);

        jLabel78.setBackground(new java.awt.Color(255, 255, 255));
        jLabel78.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel78.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel78.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel78.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel78, gridBagConstraints);

        jLabel79.setBackground(new java.awt.Color(255, 255, 255));
        jLabel79.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel79.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel79.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel79.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel79, new java.awt.GridBagConstraints());

        jLabel80.setBackground(new java.awt.Color(255, 255, 255));
        jLabel80.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel80.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel80.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel80.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel80, gridBagConstraints);

        jLabel81.setBackground(new java.awt.Color(255, 255, 255));
        jLabel81.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel81.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel81.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel81.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel81, gridBagConstraints);

        jLabel82.setBackground(new java.awt.Color(255, 255, 255));
        jLabel82.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel82.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel82.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel82.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel82, gridBagConstraints);

        jLabel83.setBackground(new java.awt.Color(255, 255, 255));
        jLabel83.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel83.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel83.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel83.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel83, gridBagConstraints);

        jLabel84.setBackground(new java.awt.Color(255, 255, 255));
        jLabel84.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel84.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel84.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel84.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel84, gridBagConstraints);

        jLabel85.setBackground(new java.awt.Color(255, 255, 255));
        jLabel85.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel85.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel85.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel85.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel85, gridBagConstraints);

        jLabel86.setBackground(new java.awt.Color(255, 255, 255));
        jLabel86.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel86.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel86.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel86.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel86, gridBagConstraints);

        jLabel87.setBackground(new java.awt.Color(255, 255, 255));
        jLabel87.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel87.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel87.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel87.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel87, gridBagConstraints);

        jLabel88.setBackground(new java.awt.Color(255, 255, 255));
        jLabel88.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel88.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel88.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel88.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel88, gridBagConstraints);

        jLabel89.setBackground(new java.awt.Color(255, 255, 255));
        jLabel89.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel89.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel89.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel89.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel89, gridBagConstraints);

        jLabel90.setBackground(new java.awt.Color(255, 255, 255));
        jLabel90.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel90.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel90.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel90.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel90, gridBagConstraints);

        jLabel91.setBackground(new java.awt.Color(255, 255, 255));
        jLabel91.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel91.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel91.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel91.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel91, gridBagConstraints);

        jLabel92.setBackground(new java.awt.Color(255, 255, 255));
        jLabel92.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel92.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel92.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel92.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel92, new java.awt.GridBagConstraints());

        jLabel93.setBackground(new java.awt.Color(255, 255, 255));
        jLabel93.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel93.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel93.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel93.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel93, gridBagConstraints);

        jLabel94.setBackground(new java.awt.Color(255, 255, 255));
        jLabel94.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel94.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel94.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel94.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel94, gridBagConstraints);

        jLabel95.setBackground(new java.awt.Color(255, 255, 255));
        jLabel95.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel95.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel95.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel95.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel95, gridBagConstraints);

        jLabel96.setBackground(new java.awt.Color(255, 255, 255));
        jLabel96.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel96.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel96.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel96.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel96, gridBagConstraints);

        jLabel97.setBackground(new java.awt.Color(255, 255, 255));
        jLabel97.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel97.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel97.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel97.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel97, gridBagConstraints);

        jLabel98.setBackground(new java.awt.Color(255, 255, 255));
        jLabel98.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel98.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel98.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel98.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel98, gridBagConstraints);

        jLabel99.setBackground(new java.awt.Color(255, 255, 255));
        jLabel99.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel99.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel99.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel99.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel99, gridBagConstraints);

        jLabel100.setBackground(new java.awt.Color(255, 255, 255));
        jLabel100.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel100.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel100.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel100.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel100, gridBagConstraints);

        jLabel101.setBackground(new java.awt.Color(255, 255, 255));
        jLabel101.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel101.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel101.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel101.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel101, gridBagConstraints);

        jLabel102.setBackground(new java.awt.Color(255, 255, 255));
        jLabel102.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel102.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel102.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel102.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel102, gridBagConstraints);

        jLabel103.setBackground(new java.awt.Color(255, 255, 255));
        jLabel103.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel103.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel103.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel103.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel103, gridBagConstraints);

        jLabel104.setBackground(new java.awt.Color(255, 255, 255));
        jLabel104.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel104.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel104.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel104.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel104, gridBagConstraints);

        jLabel105.setBackground(new java.awt.Color(255, 255, 255));
        jLabel105.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel105.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel105.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel105.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel105, new java.awt.GridBagConstraints());

        jLabel106.setBackground(new java.awt.Color(255, 255, 255));
        jLabel106.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel106.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel106.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel106.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel106, gridBagConstraints);

        jLabel107.setBackground(new java.awt.Color(255, 255, 255));
        jLabel107.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel107.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel107.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel107.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel107, gridBagConstraints);

        jLabel108.setBackground(new java.awt.Color(255, 255, 255));
        jLabel108.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel108.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel108.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel108.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel108, gridBagConstraints);

        jLabel109.setBackground(new java.awt.Color(255, 255, 255));
        jLabel109.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel109.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel109.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel109.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel109, gridBagConstraints);

        jLabel110.setBackground(new java.awt.Color(255, 255, 255));
        jLabel110.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel110.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel110.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel110.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel110, gridBagConstraints);

        jLabel111.setBackground(new java.awt.Color(255, 255, 255));
        jLabel111.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel111.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel111.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel111.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel111, gridBagConstraints);

        jLabel112.setBackground(new java.awt.Color(255, 255, 255));
        jLabel112.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel112.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel112.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel112.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel112, gridBagConstraints);

        jLabel113.setBackground(new java.awt.Color(255, 255, 255));
        jLabel113.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel113.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel113.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel113.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel113, gridBagConstraints);

        jLabel114.setBackground(new java.awt.Color(255, 255, 255));
        jLabel114.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel114.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel114.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel114.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel114, gridBagConstraints);

        jLabel115.setBackground(new java.awt.Color(255, 255, 255));
        jLabel115.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel115.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel115.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel115.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel115, gridBagConstraints);

        jLabel116.setBackground(new java.awt.Color(255, 255, 255));
        jLabel116.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel116.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel116.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel116.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel116, gridBagConstraints);

        jLabel117.setBackground(new java.awt.Color(255, 255, 255));
        jLabel117.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel117.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel117.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel117.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel117, gridBagConstraints);

        jLabel118.setBackground(new java.awt.Color(255, 255, 255));
        jLabel118.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel118.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel118.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel118.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel118, new java.awt.GridBagConstraints());

        jLabel119.setBackground(new java.awt.Color(255, 255, 255));
        jLabel119.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel119.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel119.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel119.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel119, gridBagConstraints);

        jLabel120.setBackground(new java.awt.Color(255, 255, 255));
        jLabel120.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel120.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel120.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel120.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel120, gridBagConstraints);

        jLabel121.setBackground(new java.awt.Color(255, 255, 255));
        jLabel121.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel121.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel121.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel121.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel121, gridBagConstraints);

        jLabel122.setBackground(new java.awt.Color(255, 255, 255));
        jLabel122.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel122.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel122.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel122.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel122, gridBagConstraints);

        jLabel123.setBackground(new java.awt.Color(255, 255, 255));
        jLabel123.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel123.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel123.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel123.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel123, gridBagConstraints);

        jLabel124.setBackground(new java.awt.Color(255, 255, 255));
        jLabel124.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel124.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel124.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel124.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel124, gridBagConstraints);

        jLabel125.setBackground(new java.awt.Color(255, 255, 255));
        jLabel125.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel125.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel125.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel125.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel125, gridBagConstraints);

        jLabel126.setBackground(new java.awt.Color(255, 255, 255));
        jLabel126.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel126.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel126.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel126.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel126, gridBagConstraints);

        jLabel127.setBackground(new java.awt.Color(255, 255, 255));
        jLabel127.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel127.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel127.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel127.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel127, gridBagConstraints);

        jLabel128.setBackground(new java.awt.Color(255, 255, 255));
        jLabel128.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel128.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel128.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel128.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel128, gridBagConstraints);

        jLabel129.setBackground(new java.awt.Color(255, 255, 255));
        jLabel129.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel129.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel129.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel129.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel129, gridBagConstraints);

        jLabel130.setBackground(new java.awt.Color(255, 255, 255));
        jLabel130.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel130.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel130.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel130.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel130, gridBagConstraints);

        jLabel131.setBackground(new java.awt.Color(255, 255, 255));
        jLabel131.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel131.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel131.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel131.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel131, new java.awt.GridBagConstraints());

        jLabel132.setBackground(new java.awt.Color(255, 255, 255));
        jLabel132.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel132.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel132.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel132.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel132, gridBagConstraints);

        jLabel133.setBackground(new java.awt.Color(255, 255, 255));
        jLabel133.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel133.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel133.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel133.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel133, gridBagConstraints);

        jLabel134.setBackground(new java.awt.Color(255, 255, 255));
        jLabel134.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel134.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel134.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel134.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel134, gridBagConstraints);

        jLabel135.setBackground(new java.awt.Color(255, 255, 255));
        jLabel135.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel135.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel135.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel135.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel135, gridBagConstraints);

        jLabel136.setBackground(new java.awt.Color(255, 255, 255));
        jLabel136.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel136.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel136.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel136.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel136, gridBagConstraints);

        jLabel137.setBackground(new java.awt.Color(255, 255, 255));
        jLabel137.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel137.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel137.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel137.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel137, gridBagConstraints);

        jLabel138.setBackground(new java.awt.Color(255, 255, 255));
        jLabel138.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel138.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel138.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel138.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel138, gridBagConstraints);

        jLabel139.setBackground(new java.awt.Color(255, 255, 255));
        jLabel139.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel139.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel139.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel139.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel139, gridBagConstraints);

        jLabel140.setBackground(new java.awt.Color(255, 255, 255));
        jLabel140.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel140.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel140.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel140.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel140, gridBagConstraints);

        jLabel141.setBackground(new java.awt.Color(255, 255, 255));
        jLabel141.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel141.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel141.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel141.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel141, gridBagConstraints);

        jLabel142.setBackground(new java.awt.Color(255, 255, 255));
        jLabel142.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel142.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel142.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel142.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel142, gridBagConstraints);

        jLabel143.setBackground(new java.awt.Color(255, 255, 255));
        jLabel143.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel143.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel143.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel143.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel143, gridBagConstraints);

        jLabel144.setBackground(new java.awt.Color(255, 255, 255));
        jLabel144.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel144.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel144.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel144.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel144, new java.awt.GridBagConstraints());

        jLabel145.setBackground(new java.awt.Color(255, 255, 255));
        jLabel145.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel145.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel145.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel145.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel145, gridBagConstraints);

        jLabel146.setBackground(new java.awt.Color(255, 255, 255));
        jLabel146.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel146.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel146.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel146.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel146, gridBagConstraints);

        jLabel147.setBackground(new java.awt.Color(255, 255, 255));
        jLabel147.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel147.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel147.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel147.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel147, gridBagConstraints);

        jLabel148.setBackground(new java.awt.Color(255, 255, 255));
        jLabel148.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel148.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel148.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel148.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel148, gridBagConstraints);

        jLabel149.setBackground(new java.awt.Color(255, 255, 255));
        jLabel149.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel149.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel149.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel149.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel149, gridBagConstraints);

        jLabel150.setBackground(new java.awt.Color(255, 255, 255));
        jLabel150.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel150.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel150.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel150.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel150, gridBagConstraints);

        jLabel151.setBackground(new java.awt.Color(255, 255, 255));
        jLabel151.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel151.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel151.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel151.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel151, gridBagConstraints);

        jLabel152.setBackground(new java.awt.Color(255, 255, 255));
        jLabel152.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel152.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel152.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel152.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel152, gridBagConstraints);

        jLabel153.setBackground(new java.awt.Color(255, 255, 255));
        jLabel153.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel153.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel153.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel153.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel153, gridBagConstraints);

        jLabel154.setBackground(new java.awt.Color(255, 255, 255));
        jLabel154.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel154.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel154.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel154.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel154, gridBagConstraints);

        jLabel155.setBackground(new java.awt.Color(255, 255, 255));
        jLabel155.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel155.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel155.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel155.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel155, gridBagConstraints);

        jLabel156.setBackground(new java.awt.Color(255, 255, 255));
        jLabel156.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel156.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel156.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel156.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel156, gridBagConstraints);

        jLabel157.setBackground(new java.awt.Color(255, 255, 255));
        jLabel157.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel157.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel157.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel157.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel1.add(jLabel157, new java.awt.GridBagConstraints());

        jLabel158.setBackground(new java.awt.Color(255, 255, 255));
        jLabel158.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel158.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel158.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel158.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel158, gridBagConstraints);

        jLabel159.setBackground(new java.awt.Color(255, 255, 255));
        jLabel159.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel159.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel159.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel159.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        jPanel1.add(jLabel159, gridBagConstraints);

        jLabel160.setBackground(new java.awt.Color(255, 255, 255));
        jLabel160.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel160.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel160.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel160.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        jPanel1.add(jLabel160, gridBagConstraints);

        jLabel161.setBackground(new java.awt.Color(255, 255, 255));
        jLabel161.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel161.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel161.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel161.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        jPanel1.add(jLabel161, gridBagConstraints);

        jLabel162.setBackground(new java.awt.Color(255, 255, 255));
        jLabel162.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel162.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel162.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel162.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        jPanel1.add(jLabel162, gridBagConstraints);

        jLabel163.setBackground(new java.awt.Color(255, 255, 255));
        jLabel163.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel163.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel163.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel163.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        jPanel1.add(jLabel163, gridBagConstraints);

        jLabel164.setBackground(new java.awt.Color(255, 255, 255));
        jLabel164.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel164.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel164.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel164.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        jPanel1.add(jLabel164, gridBagConstraints);

        jLabel165.setBackground(new java.awt.Color(255, 255, 255));
        jLabel165.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel165.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel165.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel165.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        jPanel1.add(jLabel165, gridBagConstraints);

        jLabel166.setBackground(new java.awt.Color(255, 255, 255));
        jLabel166.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel166.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel166.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel166.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        jPanel1.add(jLabel166, gridBagConstraints);

        jLabel167.setBackground(new java.awt.Color(255, 255, 255));
        jLabel167.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel167.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel167.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel167.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        jPanel1.add(jLabel167, gridBagConstraints);

        jLabel168.setBackground(new java.awt.Color(255, 255, 255));
        jLabel168.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel168.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel168.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel168.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 11;
        jPanel1.add(jLabel168, gridBagConstraints);

        jLabel169.setBackground(new java.awt.Color(255, 255, 255));
        jLabel169.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel169.setMaximumSize(new java.awt.Dimension(200, 200));
        jLabel169.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel169.setPreferredSize(new java.awt.Dimension(20, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 12;
        jPanel1.add(jLabel169, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        jPanel3.add(jPanel1, gridBagConstraints);

        jPanel26.setBackground(new java.awt.Color(245, 245, 245));
        jPanel26.setLayout(new java.awt.GridBagLayout());

        jPanel10.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel10.setPreferredSize(new java.awt.Dimension(76, 32));

        jLabel188.setText("Play:    ");
        jPanel10.add(jLabel188);

        jLabel189.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel189.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel10.add(jLabel189);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel26.add(jPanel10, gridBagConstraints);

        jPanel4.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel172.setText("Discard:");
        jPanel4.add(jLabel172);

        jLabel171.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel171.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel4.add(jLabel171);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        jPanel26.add(jPanel4, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel3.add(jPanel26, gridBagConstraints);

        jButton1.setLabel("Next Turn (100)");
        jButton1.setMaximumSize(new java.awt.Dimension(100, 23));
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1MouseClicked(evt);
            }
        });
        jPanel27.add(jButton1);

        jButton2.setText("Show Round 1");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton2MouseClicked(evt);
            }
        });
        jPanel27.add(jButton2);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 3;
        jPanel3.add(jPanel27, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(jPanel3, gridBagConstraints);

        jPanel2.setBackground(new java.awt.Color(245, 245, 245));
        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Legend", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Aharoni", 1, 14))); // NOI18N
        jPanel2.setMaximumSize(null);
        jPanel2.setMinimumSize(null);
        jPanel2.setPreferredSize(new java.awt.Dimension(250, 600));
        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel17.setBackground(new java.awt.Color(153, 204, 255));
        jPanel17.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel190.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/red.PNG"))); // NOI18N
        jLabel190.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel190.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jPanel17.add(jLabel190);

        jLabel229.setText("Block           ");
        jPanel17.add(jLabel229);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jPanel17, gridBagConstraints);

        jPanel18.setBackground(new java.awt.Color(153, 204, 255));
        jPanel18.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel230.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG"))); // NOI18N
        jLabel230.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel18.add(jLabel230);

        jLabel231.setText("Stone         ");
        jPanel18.add(jLabel231);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jPanel18, gridBagConstraints);

        jPanel19.setBackground(new java.awt.Color(153, 204, 255));
        jPanel19.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel232.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/turnleftupclosed.PNG"))); // NOI18N
        jLabel232.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel19.add(jLabel232);

        jLabel233.setText("Closed Path");
        jPanel19.add(jLabel233);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jPanel19, gridBagConstraints);

        jPanel20.setBackground(new java.awt.Color(153, 204, 255));
        jPanel20.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel234.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/green.PNG"))); // NOI18N
        jLabel234.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel20.add(jLabel234);

        jLabel235.setText("Deblock       ");
        jPanel20.add(jLabel235);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jPanel20, gridBagConstraints);

        jPanel21.setBackground(new java.awt.Color(153, 204, 255));
        jPanel21.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel236.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG"))); // NOI18N
        jLabel236.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel21.add(jLabel236);

        jLabel237.setText("Gold            ");
        jPanel21.add(jLabel237);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jPanel21, gridBagConstraints);

        jPanel22.setBackground(new java.awt.Color(153, 204, 255));
        jPanel22.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel238.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/demolish.PNG"))); // NOI18N
        jLabel238.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel22.add(jLabel238);

        jLabel239.setText("Demolish     ");
        jPanel22.add(jLabel239);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jPanel22, gridBagConstraints);

        jPanel23.setBackground(new java.awt.Color(153, 204, 255));
        jPanel23.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel240.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/view.PNG"))); // NOI18N
        jLabel240.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel23.add(jLabel240);

        jLabel241.setText("View            ");
        jPanel23.add(jLabel241);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jPanel23, gridBagConstraints);

        jPanel24.setBackground(new java.awt.Color(153, 204, 255));
        jPanel24.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel242.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel242.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/start.PNG"))); // NOI18N
        jLabel242.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel24.add(jLabel242);

        jLabel243.setText("Start           ");
        jPanel24.add(jLabel243);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jPanel24, gridBagConstraints);

        jPanel25.setBackground(new java.awt.Color(153, 204, 255));
        jPanel25.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel244.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/tdown.PNG"))); // NOI18N
        jLabel244.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel25.add(jLabel244);

        jLabel245.setText("Open Path  ");
        jPanel25.add(jLabel245);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jPanel25, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(jPanel2, gridBagConstraints);

        jPanel16.setBackground(new java.awt.Color(245, 245, 245));
        jPanel16.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Hand Cards", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Aharoni", 1, 14))); // NOI18N
        jPanel16.setMaximumSize(null);
        jPanel16.setMinimumSize(null);
        jPanel16.setPreferredSize(new java.awt.Dimension(250, 400));
        jPanel16.setLayout(new java.awt.GridBagLayout());

        jPanel5.setBackground(new java.awt.Color(0, 204, 102));
        jPanel5.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel5.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel221.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel5.add(jLabel221);

        jLabel178.setText("0: Agent   ");
        jPanel5.add(jLabel178);

        jLabel179.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel179.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel5.add(jLabel179);

        jLabel170.setText("jLabel170");
        jPanel5.add(jLabel170);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel5, gridBagConstraints);

        jPanel11.setBackground(new java.awt.Color(153, 204, 255));
        jPanel11.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel11.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel191.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel191.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel11.add(jLabel191);

        jLabel192.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel192.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel11.add(jLabel192);

        jLabel193.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel193.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel11.add(jLabel193);

        jLabel194.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel194.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel11.add(jLabel194);

        jLabel195.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel195.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel11.add(jLabel195);

        jLabel196.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel196.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel11.add(jLabel196);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel11, gridBagConstraints);

        jPanel6.setBackground(new java.awt.Color(0, 204, 102));
        jPanel6.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel6.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel222.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel6.add(jLabel222);

        jLabel180.setText("1: Agent   ");
        jPanel6.add(jLabel180);

        jLabel181.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel181.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel6.add(jLabel181);

        jLabel173.setText("jLabel173");
        jPanel6.add(jLabel173);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel6, gridBagConstraints);

        jPanel12.setBackground(new java.awt.Color(153, 204, 255));
        jPanel12.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel12.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel197.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel197.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel12.add(jLabel197);

        jLabel198.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel198.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel12.add(jLabel198);

        jLabel199.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel199.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel12.add(jLabel199);

        jLabel200.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel200.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel12.add(jLabel200);

        jLabel201.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel201.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel12.add(jLabel201);

        jLabel202.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel202.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel12.add(jLabel202);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel12, gridBagConstraints);

        jPanel7.setBackground(new java.awt.Color(0, 204, 102));
        jPanel7.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel7.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel223.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel7.add(jLabel223);

        jLabel182.setText("2: Agent   ");
        jPanel7.add(jLabel182);

        jLabel183.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel183.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel7.add(jLabel183);

        jLabel174.setText("jLabel174");
        jPanel7.add(jLabel174);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel7, gridBagConstraints);

        jPanel13.setBackground(new java.awt.Color(153, 204, 255));
        jPanel13.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel13.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel203.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel203.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel13.add(jLabel203);

        jLabel204.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel204.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel13.add(jLabel204);

        jLabel205.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel205.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel13.add(jLabel205);

        jLabel206.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel206.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel13.add(jLabel206);

        jLabel207.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel207.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel13.add(jLabel207);

        jLabel208.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel208.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel13.add(jLabel208);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel13, gridBagConstraints);

        jPanel8.setBackground(new java.awt.Color(0, 204, 102));
        jPanel8.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel8.setMinimumSize(new java.awt.Dimension(49, 14));

        jLabel224.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel8.add(jLabel224);

        jLabel184.setText("3: Agent   ");
        jPanel8.add(jLabel184);

        jLabel185.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel185.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel8.add(jLabel185);

        jLabel175.setText("jLabel175");
        jPanel8.add(jLabel175);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel8, gridBagConstraints);

        jPanel14.setBackground(new java.awt.Color(153, 204, 255));
        jPanel14.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel14.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel209.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel209.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel14.add(jLabel209);

        jLabel210.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel210.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel14.add(jLabel210);

        jLabel211.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel211.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel14.add(jLabel211);

        jLabel212.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel212.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel14.add(jLabel212);

        jLabel213.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel213.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel14.add(jLabel213);

        jLabel214.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel214.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel14.add(jLabel214);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel14, gridBagConstraints);

        jPanel9.setBackground(new java.awt.Color(0, 204, 102));
        jPanel9.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel9.setMinimumSize(new java.awt.Dimension(49, 14));

        jLabel225.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel9.add(jLabel225);

        jLabel186.setText("4: Agent   ");
        jPanel9.add(jLabel186);

        jLabel187.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel187.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel9.add(jLabel187);

        jLabel176.setText("jLabel176");
        jPanel9.add(jLabel176);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel9, gridBagConstraints);

        jPanel15.setBackground(new java.awt.Color(153, 204, 255));
        jPanel15.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel15.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel215.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel215.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel15.add(jLabel215);

        jLabel216.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel216.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel15.add(jLabel216);

        jLabel217.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel217.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel15.add(jLabel217);

        jLabel218.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel218.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel15.add(jLabel218);

        jLabel219.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel219.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel15.add(jLabel219);

        jLabel220.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel220.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel15.add(jLabel220);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel15, gridBagConstraints);

        jPanel28.setBackground(new java.awt.Color(204, 204, 0));
        jPanel28.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel28.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel226.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel226.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel28.add(jLabel226);

        jLabel227.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel227.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel28.add(jLabel227);

        jLabel228.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel228.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel28.add(jLabel228);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel28, gridBagConstraints);

        jPanel29.setBackground(new java.awt.Color(204, 204, 0));
        jPanel29.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel29.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel246.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel246.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel29.add(jLabel246);

        jLabel247.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel247.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel29.add(jLabel247);

        jLabel248.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel248.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel29.add(jLabel248);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel29, gridBagConstraints);

        jPanel30.setBackground(new java.awt.Color(204, 204, 0));
        jPanel30.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel30.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel249.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel249.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel30.add(jLabel249);

        jLabel250.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel250.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel30.add(jLabel250);

        jLabel251.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel251.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel30.add(jLabel251);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel30, gridBagConstraints);

        jPanel31.setBackground(new java.awt.Color(204, 204, 0));
        jPanel31.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel31.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel252.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel252.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel31.add(jLabel252);

        jLabel253.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel253.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel31.add(jLabel253);

        jLabel254.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel254.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel31.add(jLabel254);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 14;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel31, gridBagConstraints);

        jPanel32.setBackground(new java.awt.Color(204, 204, 0));
        jPanel32.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel32.setMinimumSize(new java.awt.Dimension(49, 30));

        jLabel255.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel255.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel32.add(jLabel255);

        jLabel256.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel256.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel32.add(jLabel256);

        jLabel257.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel257.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel32.add(jLabel257);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel16.add(jPanel32, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jPanel16, gridBagConstraints);

        jScrollPane2.setAutoscrolls(true);
        jScrollPane2.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jScrollPane2.setMaximumSize(null);
        jScrollPane2.setMinimumSize(null);
        jScrollPane2.setNextFocusableComponent(jTextArea1);
        jScrollPane2.setPreferredSize(null);

        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setRows(5);
        jScrollPane2.setViewportView(jTextArea1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.gridheight = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        getContentPane().add(jScrollPane2, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1MouseClicked
        jLabel189.setIcon(null);
        jLabel171.setIcon(null);
        next = true;
    }//GEN-LAST:event_jButton1MouseClicked

    private void jButton2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton2MouseClicked
        show = true;
    }//GEN-LAST:event_jButton2MouseClicked

    /**
     * @param args the command line arguments
     */

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel100;
    private javax.swing.JLabel jLabel101;
    private javax.swing.JLabel jLabel102;
    private javax.swing.JLabel jLabel103;
    private javax.swing.JLabel jLabel104;
    private javax.swing.JLabel jLabel105;
    private javax.swing.JLabel jLabel106;
    private javax.swing.JLabel jLabel107;
    private javax.swing.JLabel jLabel108;
    private javax.swing.JLabel jLabel109;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel110;
    private javax.swing.JLabel jLabel111;
    private javax.swing.JLabel jLabel112;
    private javax.swing.JLabel jLabel113;
    private javax.swing.JLabel jLabel114;
    private javax.swing.JLabel jLabel115;
    private javax.swing.JLabel jLabel116;
    private javax.swing.JLabel jLabel117;
    private javax.swing.JLabel jLabel118;
    private javax.swing.JLabel jLabel119;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel120;
    private javax.swing.JLabel jLabel121;
    private javax.swing.JLabel jLabel122;
    private javax.swing.JLabel jLabel123;
    private javax.swing.JLabel jLabel124;
    private javax.swing.JLabel jLabel125;
    private javax.swing.JLabel jLabel126;
    private javax.swing.JLabel jLabel127;
    private javax.swing.JLabel jLabel128;
    private javax.swing.JLabel jLabel129;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel130;
    private javax.swing.JLabel jLabel131;
    private javax.swing.JLabel jLabel132;
    private javax.swing.JLabel jLabel133;
    private javax.swing.JLabel jLabel134;
    private javax.swing.JLabel jLabel135;
    private javax.swing.JLabel jLabel136;
    private javax.swing.JLabel jLabel137;
    private javax.swing.JLabel jLabel138;
    private javax.swing.JLabel jLabel139;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel140;
    private javax.swing.JLabel jLabel141;
    private javax.swing.JLabel jLabel142;
    private javax.swing.JLabel jLabel143;
    private javax.swing.JLabel jLabel144;
    private javax.swing.JLabel jLabel145;
    private javax.swing.JLabel jLabel146;
    private javax.swing.JLabel jLabel147;
    private javax.swing.JLabel jLabel148;
    private javax.swing.JLabel jLabel149;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel150;
    private javax.swing.JLabel jLabel151;
    private javax.swing.JLabel jLabel152;
    private javax.swing.JLabel jLabel153;
    private javax.swing.JLabel jLabel154;
    private javax.swing.JLabel jLabel155;
    private javax.swing.JLabel jLabel156;
    private javax.swing.JLabel jLabel157;
    private javax.swing.JLabel jLabel158;
    private javax.swing.JLabel jLabel159;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel160;
    private javax.swing.JLabel jLabel161;
    private javax.swing.JLabel jLabel162;
    private javax.swing.JLabel jLabel163;
    private javax.swing.JLabel jLabel164;
    private javax.swing.JLabel jLabel165;
    private javax.swing.JLabel jLabel166;
    private javax.swing.JLabel jLabel167;
    private javax.swing.JLabel jLabel168;
    private javax.swing.JLabel jLabel169;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel170;
    private javax.swing.JLabel jLabel171;
    private javax.swing.JLabel jLabel172;
    private javax.swing.JLabel jLabel173;
    private javax.swing.JLabel jLabel174;
    private javax.swing.JLabel jLabel175;
    private javax.swing.JLabel jLabel176;
    private javax.swing.JLabel jLabel178;
    private javax.swing.JLabel jLabel179;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel180;
    private javax.swing.JLabel jLabel181;
    private javax.swing.JLabel jLabel182;
    private javax.swing.JLabel jLabel183;
    private javax.swing.JLabel jLabel184;
    private javax.swing.JLabel jLabel185;
    private javax.swing.JLabel jLabel186;
    private javax.swing.JLabel jLabel187;
    private javax.swing.JLabel jLabel188;
    private javax.swing.JLabel jLabel189;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel190;
    private javax.swing.JLabel jLabel191;
    private javax.swing.JLabel jLabel192;
    private javax.swing.JLabel jLabel193;
    private javax.swing.JLabel jLabel194;
    private javax.swing.JLabel jLabel195;
    private javax.swing.JLabel jLabel196;
    private javax.swing.JLabel jLabel197;
    private javax.swing.JLabel jLabel198;
    private javax.swing.JLabel jLabel199;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel200;
    private javax.swing.JLabel jLabel201;
    private javax.swing.JLabel jLabel202;
    private javax.swing.JLabel jLabel203;
    private javax.swing.JLabel jLabel204;
    private javax.swing.JLabel jLabel205;
    private javax.swing.JLabel jLabel206;
    private javax.swing.JLabel jLabel207;
    private javax.swing.JLabel jLabel208;
    private javax.swing.JLabel jLabel209;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel210;
    private javax.swing.JLabel jLabel211;
    private javax.swing.JLabel jLabel212;
    private javax.swing.JLabel jLabel213;
    private javax.swing.JLabel jLabel214;
    private javax.swing.JLabel jLabel215;
    private javax.swing.JLabel jLabel216;
    private javax.swing.JLabel jLabel217;
    private javax.swing.JLabel jLabel218;
    private javax.swing.JLabel jLabel219;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel220;
    private javax.swing.JLabel jLabel221;
    private javax.swing.JLabel jLabel222;
    private javax.swing.JLabel jLabel223;
    private javax.swing.JLabel jLabel224;
    private javax.swing.JLabel jLabel225;
    private javax.swing.JLabel jLabel226;
    private javax.swing.JLabel jLabel227;
    private javax.swing.JLabel jLabel228;
    private javax.swing.JLabel jLabel229;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel230;
    private javax.swing.JLabel jLabel231;
    private javax.swing.JLabel jLabel232;
    private javax.swing.JLabel jLabel233;
    private javax.swing.JLabel jLabel234;
    private javax.swing.JLabel jLabel235;
    private javax.swing.JLabel jLabel236;
    private javax.swing.JLabel jLabel237;
    private javax.swing.JLabel jLabel238;
    private javax.swing.JLabel jLabel239;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel240;
    private javax.swing.JLabel jLabel241;
    private javax.swing.JLabel jLabel242;
    private javax.swing.JLabel jLabel243;
    private javax.swing.JLabel jLabel244;
    private javax.swing.JLabel jLabel245;
    private javax.swing.JLabel jLabel246;
    private javax.swing.JLabel jLabel247;
    private javax.swing.JLabel jLabel248;
    private javax.swing.JLabel jLabel249;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel250;
    private javax.swing.JLabel jLabel251;
    private javax.swing.JLabel jLabel252;
    private javax.swing.JLabel jLabel253;
    private javax.swing.JLabel jLabel254;
    private javax.swing.JLabel jLabel255;
    private javax.swing.JLabel jLabel256;
    private javax.swing.JLabel jLabel257;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel36;
    private javax.swing.JLabel jLabel37;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel39;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel40;
    private javax.swing.JLabel jLabel41;
    private javax.swing.JLabel jLabel42;
    private javax.swing.JLabel jLabel43;
    private javax.swing.JLabel jLabel44;
    private javax.swing.JLabel jLabel45;
    private javax.swing.JLabel jLabel46;
    private javax.swing.JLabel jLabel47;
    private javax.swing.JLabel jLabel48;
    private javax.swing.JLabel jLabel49;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel50;
    private javax.swing.JLabel jLabel51;
    private javax.swing.JLabel jLabel52;
    private javax.swing.JLabel jLabel53;
    private javax.swing.JLabel jLabel54;
    private javax.swing.JLabel jLabel55;
    private javax.swing.JLabel jLabel56;
    private javax.swing.JLabel jLabel57;
    private javax.swing.JLabel jLabel58;
    private javax.swing.JLabel jLabel59;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel60;
    private javax.swing.JLabel jLabel61;
    private javax.swing.JLabel jLabel62;
    private javax.swing.JLabel jLabel63;
    private javax.swing.JLabel jLabel64;
    private javax.swing.JLabel jLabel65;
    private javax.swing.JLabel jLabel66;
    private javax.swing.JLabel jLabel67;
    private javax.swing.JLabel jLabel68;
    private javax.swing.JLabel jLabel69;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel70;
    private javax.swing.JLabel jLabel71;
    private javax.swing.JLabel jLabel72;
    private javax.swing.JLabel jLabel73;
    private javax.swing.JLabel jLabel74;
    private javax.swing.JLabel jLabel75;
    private javax.swing.JLabel jLabel76;
    private javax.swing.JLabel jLabel77;
    private javax.swing.JLabel jLabel78;
    private javax.swing.JLabel jLabel79;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel80;
    private javax.swing.JLabel jLabel81;
    private javax.swing.JLabel jLabel82;
    private javax.swing.JLabel jLabel83;
    private javax.swing.JLabel jLabel84;
    private javax.swing.JLabel jLabel85;
    private javax.swing.JLabel jLabel86;
    private javax.swing.JLabel jLabel87;
    private javax.swing.JLabel jLabel88;
    private javax.swing.JLabel jLabel89;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabel90;
    private javax.swing.JLabel jLabel91;
    private javax.swing.JLabel jLabel92;
    private javax.swing.JLabel jLabel93;
    private javax.swing.JLabel jLabel94;
    private javax.swing.JLabel jLabel95;
    private javax.swing.JLabel jLabel96;
    private javax.swing.JLabel jLabel97;
    private javax.swing.JLabel jLabel98;
    private javax.swing.JLabel jLabel99;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel19;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel21;
    private javax.swing.JPanel jPanel22;
    private javax.swing.JPanel jPanel23;
    private javax.swing.JPanel jPanel24;
    private javax.swing.JPanel jPanel25;
    private javax.swing.JPanel jPanel26;
    private javax.swing.JPanel jPanel27;
    private javax.swing.JPanel jPanel28;
    private javax.swing.JPanel jPanel29;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel30;
    private javax.swing.JPanel jPanel31;
    private javax.swing.JPanel jPanel32;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea jTextArea1;
    // End of variables declaration//GEN-END:variables

    void setGoalCards(int i, boolean gold, int agent) {
        if(agent == 0) {
            if(i == 0) {
                if(gold == true) {
                    jLabel255.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                    jLabel256.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                    jLabel257.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                    jLabel255.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG"))); 
                }
            } else if(i == 1) {
                if(gold == true) {
                   jLabel256.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                   jLabel255.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                   jLabel257.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                   jLabel256.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                }                
            } else {
                if(gold == true) {
                    jLabel257.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                    jLabel255.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                    jLabel256.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                    jLabel257.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                }   
            }
        } else if(agent == 1) {
            if(i == 0) {
                if(gold == true) {
                    jLabel226.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                    jLabel227.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                    jLabel228.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                    jLabel226.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG"))); 
                }
            } else if(i == 1) {
                if(gold == true) {
                   jLabel227.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                   jLabel228.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                   jLabel226.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                   jLabel227.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                }                
            } else {
                if(gold == true) {
                    jLabel228.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                    jLabel227.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                    jLabel226.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                    jLabel228.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                }   
            }
        } else if(agent == 2) {
            if(i == 0) {
                if(gold == true) {
                    jLabel246.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                    jLabel247.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                    jLabel248.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                    jLabel246.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG"))); 
                }
            } else if(i == 1) {
                if(gold == true) {
                   jLabel247.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                   jLabel246.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                   jLabel248.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                   jLabel247.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                }                
            } else {
                if(gold == true) {
                    jLabel248.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                    jLabel247.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                    jLabel246.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                    jLabel248.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                }   
            }            
        } else if(agent == 3) {
            if(i == 0) {
                if(gold == true) {
                    jLabel249.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                    jLabel250.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                    jLabel251.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                    jLabel249.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG"))); 
                }
            } else if(i == 1) {
                if(gold == true) {
                   jLabel250.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                   jLabel249.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                   jLabel251.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                   jLabel250.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                }                
            } else {
                if(gold == true) {
                    jLabel251.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                    jLabel250.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                    jLabel249.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                    jLabel251.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                }   
            }            
        } else if(agent == 4) {                        
            if(i == 0) {
                if(gold == true) {
                    jLabel252.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                    jLabel253.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                    jLabel254.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                    jLabel252.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG"))); 
                }
            } else if(i == 1) {
                if(gold == true) {
                   jLabel253.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                   jLabel252.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                   jLabel254.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                   jLabel253.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                }                
            } else {
                if(gold == true) {
                    jLabel254.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/gold.PNG")));
                    jLabel253.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                    jLabel252.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                } else {
                    jLabel254.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/stone.PNG")));
                }   
            }                                                
        }
    }

    void initializeGoalCards() {
        jLabel255.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel256.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel257.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel226.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel227.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel228.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel246.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel247.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel248.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel249.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel250.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel251.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel252.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel253.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
        jLabel254.setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/unknown.PNG")));
    }

    void addText(String string) {
        jTextArea1.append(string);  
        jTextArea1.selectAll();
    }
}
